#include <stdio.h>
#include <math.h>
#include <conio.h>

float Simpson(float local_a,float local_b, int local_n, float h);
float Error_Simpson(float local_a,float local_b, int local_n, float h);

void main(int argc,char* argv[])
{
	// VARIABLES del PROBLEMA
	float a,b,h,total,error;
   long int n;

    printf("Ingrese el borde A: \n");scanf("%f",&a);
	printf("Ingrese el borde B: \n");scanf("%f",&b);
	printf("Ingrese  N: \n");scanf("%d",&n);

	h = (b-a)/n;    		// h es el mismo para todos los programas.
	error=0.0;

	//Calculo de la integral en el intervalo local del proceso
	total = Simpson(a, b, n, h);
   error = Error_Simpson(a, b, n, h);

	printf("Resultado de la integral [%f,%f] con n=%ld: %f\n", a, b, n, total);

   printf("Error: %f \n",error);
   getch();


}

// Funcion a integrar
float f(float x)
{
	return (exp(x)*x*x);
}

float Dfcta(float x)
{
    return(exp(x)*x*x+8*x*exp(x)+12*exp(x));

}

// Formula de Simpson
float Simpson(float local_a,float local_b, int local_n, float h)
{
	float x, integral;
	int i,l;
	integral = (f(local_a) + f(local_b));
	x = local_a;
 l = 0;
	for(i = 1; i <= local_n-1; i++)
	{
		l = 1 - l;
		x = x + h;
		integral = integral + (2 + l * 2) * f(x);
	}
	integral = integral * h / 3.0;
	return integral;
}

float Error_Simpson(float local_a,float local_b, int local_n, float h)
{
    float nu,cte,error=0.0;
    int kk;

//    cte=3*pow(h,5)/80.0;
    cte=3*(h*h*h*h*h)/80.0;

    for(kk=1;kk<=local_n;kk++)
    {
       nu = (local_a + 2*h*kk)*0.5;
       error = error + Dfcta(nu);
    }
	printf("%f %f %f\n",cte,error,h);

    return (cte*error);

}
