#include <stdio.h>
#include <math.h>
#include <stdlib.h>

/*
GaussSeidel.c resulve el sistema A*x=B por el metodo G-S.
La iteracion continua hasta que la norma infinita PHIN A*x-B sea menor que epsilon
*/

void main()
{
float a[100][100],b[100],x[100],r[100],xi[100],eps=0.001,tr,el,phin,div;
int nord;
int i,j,p,m,t,k;

a[0][0]= 3.0;
a[0][1]= 2.0;
a[0][2]= 0.0;

a[1][0]= 0.0;
a[1][1]= 1.0;
a[1][2]= 0.8;

a[2][0]= 1.0;
a[2][1]= 1.0;
a[2][2]= 7.0;


b[0]=1;
b[1]=0;
b[2]=0;

nord=3;
phin=0;
m=1;

// residuo inicial
for(i=0;i<nord;i++)
{
   tr=0;
//	for(j=0;j<nord;j++)
//   	tr=tr+ a[i][j] * xi[j];
   r[i]=tr-b[i];

   if(abs(r[i])>=phin)
      phin=abs(r[i]);
}


while(phin > eps && m < 20)
{
    t= m -(m/nord)*nord;
    p=t-1;
    if(t==0) p=nord-1;

    el=r[p]/a[p][p];
//    xi[p]=xi[p]-el;

    r[p]=b[p]/a[p][p];

    phin=0;
    for(i=0;i<=p-1;i++)
    {
        r[p]=r[p]-a[i][p]*r[i]/a[p][p];
        if( fabs(r[p]) > phin ) phin=fabs(r[p]);
        printf("%i %f %f\n",i,phin,fabs(r[p]));
    }
    for(i=p+1;i<nord;i++)
    {
        r[p]=r[p]-a[i][p]*r[i]/a[p][p];//*el;
        if( fabs(r[p]) > phin)       phin=fabs(r[p]);
        printf("%i %f %f\n",i,phin,fabs(r[p]));
    }

    m=m+1;
    printf("%i %f\n",m,phin);

}



for(i=0;i<nord;i++)
	x[i]=xi[i];

for(i=0;i<nord;i++)
    printf("%f %f\n",x[i],r[i]);

}




